/*
iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/

#include<menuet/os.h>
#include <kosgl.h> //TinyGL
#include <string.h>

#include "SysCall.h"
#include "ProcessTab.h"


int Fps (long x, long y);
extern "C"{
void app_main(void);
}

struct {
	   int x,y;
	   int dx,dy;
	   } win;

#define KEY_ESC       1
#define KEY_F     	 33

char *title1 = "TinyGL in KolibriOS";
char *title2 = "F full screen";
char *title3 = "ESC - exit";
char *fps    = "FPS:";

unsigned char FullScreen = 0;
unsigned char skin = 3;

process_table_entry_* pri;
KOSGLContext cgl;


float angle;
GLUquadricObj* qobj;
float dangle = 0.1;

GLfloat lightpos[4] = {0.0, 0.7, 0.0, 1.0};

void DrawGL() //
{
 glLoadIdentity();                                                                               //   
 glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);           

 glTranslatef(0.0, 0.0, -6.0);                
 glRotatef(angle, 0.0, 1.0, 0.0);   
  
 glColor3f(0.8, 0.8, 0.8);
 drawTorus(0.4,35,1.0,35);
 
 glPushMatrix(); 
 glRotatef(-6.0*angle, 0.0, 1.0, 0.0);  
 glTranslatef(2.0, 0.0, 0.0);
  
 glLightfv(GL_LIGHT0, GL_POSITION, lightpos); 
 gluSphere (qobj, 0.2, 25, 25);
 glPopMatrix();
  
 kosglSwapBuffers(); 
 } 

void reshape()
{   
   __menuet__get_process_table((process_table_entry*)pri,-1);
   glViewport(0, 0, pri->winx_size, pri->winy_size-20);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(45.0, (GLfloat)pri->winx_size/pri->winy_size, 1.0, 30.0);
   glMatrixMode(GL_MODELVIEW);
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );  
}

void disabletgl()
{
	kosglDestroyContext(cgl); 
	delete pri;
}
 
void Title()
{
     __menuet__write_text(300,8,0x10ffffff,fps,strlen(fps));
     __menuet__write_text(8,8,0x10ffffff,title1,strlen(title1));
	 __menuet__write_text(180,8,0x00ffffff,title2,strlen(title2));
     __menuet__write_text(600,8,0x00ffffff,title3,strlen(title3));
}

void draw_window(void)
{
	// start redraw
	__menuet__window_redraw(1);
	// define&draw window
	__menuet__define_window(win.x,win.y,win.dx,win.dy,TYPEWIN(0,0,0,1,skin,0,0,0),0,0);
    // end redraw
    __menuet__window_redraw(2);
    // display string
    Title();
}

void app_main(void)          
{
	 
  win.x = 100;
  win.y = 100;
  win.dx = 400;
  win.dy = 400;

  draw_window();

  cgl = kosglCreateContext( 0, 0);
  kosglMakeCurrent( 0, 20, win.dx, win.dy-20, cgl);
  
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
    
  glEnable(GL_LIGHTING);
  glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 0.0);
  glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 180.0);
  glEnable(GL_LIGHT0);

  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_NORMALIZE);
  glClearDepth(1.0);
  glEnable( GL_CULL_FACE );
  glEnable(GL_DEPTH_TEST);
 
  qobj = gluNewQuadric();
  
  pri=new process_table_entry_;
  SysCall(66,1,1);

  reshape();

do{

 if (angle < 360.0) angle += 0.001 + 0.05*Fps (330,8);
                      else angle = 0.0; 

 DrawGL();

		  switch(__menuet__check_for_event())
		      {
		          case 1: draw_window();				  	   	  
				  	   	  reshape();
				  	   	  break;
				  	   	  
		          case 2: 		          
		          	   switch(__menuet__getkey()){

						   case KEY_F:
                                    if(!FullScreen){									 
									 skin=0;
									 SysCall(67,0,0,SysCall(14)>>16,SysCall(14)&0xffff);
									 draw_window();
									 reshape();
									 FullScreen = 1;
									}
									else{
									 skin=3;
									 draw_window();								 
									 SysCall(67,win.x,win.y,win.dx,win.dy);
									 reshape();
									 FullScreen = 0;
									};
						  			break;
		          
                           case KEY_ESC: disabletgl();
						  				 return;}
						  				 break;
						  			
			  	  case 3: disabletgl();
						  return;
		      }
}while(1);
}
